<template>
  <div class="sa-input-file input">
    <div
      role="button"
      :aria-label="label"
      tabindex="0"
      @keydown.space.prevent="openDialog"
      @keydown.enter="openDialog"
    >
      <label :for="uniqueId" hidden>Uploaded file</label>
      <input
        :id="uniqueId"
        type="text"
        autocomplete="off"
        readonly
        tabindex="-1"
        :placeholder="placeholder"
        :value="filename"
      />
      <sa-button ref="button" :text="label" size="small" tabindex="-1" />
    </div>
    <input ref="input" tabindex="-1" type="file" @change="onFileChange" />
  </div>
</template>

<script>
export default {
  name: 'SaInputFile',
  props: {
    label: {
      type: String,
      default: 'Upload a file'
    },
    placeholder: {
      type: String,
      default: ''
    }
  },
  data() {
    return {
      uniqueId: this.makeUniqueId(),
      filename: null
    }
  },
  methods: {
    onFileChange(e) {
      const file = this.getFile(e)
      this.filename = file ? file.name : null
      this.$emit('input', file)
    },
    getFile(e) {
      return e.target.files[0]
    },
    openDialog() {
      this.$refs.input.click()
    }
  }
}
</script>

<style lang="scss" scoped>
.sa-input-file {
  position: relative;
  overflow: hidden;
  // button can't get focus, so apply styling as if it could
  &:hover,
  &:focus {
    .button {
      background: mix(white, color(primary), 20%);
    }
  }

  [role='button'] {
    display: flex;
    width: 100%;
    padding: spacing(0);
  }

  input[type='file'] {
    position: absolute;
    top: 0;
    bottom: 0;
    width: 100%;
    opacity: 0;
    cursor: pointer;
  }

  input[type='text'] {
    padding: 0 spacing(1);
    overflow: hidden;
    text-overflow: ellipsis;
    flex: 1 1 auto;
  }
}
</style>
